<template>
  <fieldset>
    <template v-if="!currentSettings.applicationId">
      <p>
        <a
          href="https://portal.azure.com/#blade/Microsoft_AAD_IAM/ActiveDirectoryMenuBlade/RegisteredApps"
          target="_blank"
        >
          {{ t("mstodo_setup_credentials") }}
        </a>
      </p>
      <details class="mstodo--selectable">
        <summary>{{ t("mstodo_instructions_summary") }}</summary>
        <ol style="line-break: normal">
          <li>{{ t("mstodo_step_1") }}</li>
          <li>{{ t("mstodo_step_2") }}</li>
          <li>
            {{ t("mstodo_step_3") }}
            <ul>
              <li>{{ t("mstodo_step_3_1") }}</li>
              <li>{{ t("mstodo_step_3_2") }}</li>
              <li>{{ t("mstodo_step_3_3") }}</li>
            </ul>
          </li>
          <li>{{ t("mstodo_step_4") }}</li>
          <li>{{ t("mstodo_step_5") }}</li>
          <li>{{ t("mstodo_step_6") }}</li>
          <li>{{ t("mstodo_step_7") }}</li>
        </ol>
      </details>
      <br />
    </template>
    <p v-if="currentSettings.applicationId && !currentSettings.graphTokenHash">
      <strong style="font-size: larger"
        ><a :href="`${$root.$options.backendUrl}auth/microsoft_graph_auth`">
          {{ t("Connect to Microsoft account") }}
        </a></strong
      >
    </p>
    <p v-else-if="currentSettings.applicationId && currentSettings.graphTokenHash">
      {{ t("mstodo_success") }}
    </p>
    <TextInputFloatingLabel for="applicationId" :text="t('Application ID')">
      <input
        type="text"
        name="applicationId"
        id="applicationId"
        :value="currentSettings.applicationId"
        placeholder=""
        :disabled="currentSettings.applicationId"
      />
    </TextInputFloatingLabel>
    <TextInputFloatingLabel for="clientSecret" :text="t('Client secret')">
      <input
        type="text"
        name="clientSecret"
        id="clientSecret"
        :value="currentSettings.clientSecret"
        placeholder=""
        :disabled="currentSettings.clientSecret"
      />
    </TextInputFloatingLabel>
    <TextInputFloatingLabel for="mirrosSettingsLocation" :text="t('')">
      <input
        type="hidden"
        name="mirrosSettingsLocation"
        id="mirrosSettingsLocation"
        :value="mirrosSettingsLocation()"
        placeholder=""
      />
    </TextInputFloatingLabel>
  </fieldset>
</template>

<script>
module.exports = {
  name: "microsoft_todo",
  props: {
    currentSettings: {
      type: Object,
      required: false,
      default: function () {
        return {
          applicationId: undefined,
          clientSecret: undefined,
          graphTokenHash: undefined
        }
      }
    },
    locale: {
      type: String,
      required: true,
    },
  },
  methods: {
    mirrosSettingsLocation: function () {
      return location;
    },
  },
  locales: {
    enGb: {
      mstodo_setup_credentials:
        "Please create a new Azure AD app to generate your credentials.",
      mstodo_instructions_summary: "See detailed instructions",
      mstodo_step_1:
        "Login using a personal account (aka: Microsoft Account) or Work or School Account.",
      mstodo_step_2:
        "Select Azure Active Directory in the left-hand navigation, then select App registrations under Manage.",
      mstodo_step_3:
        "Select New registration. On the Register an application page, set the values as follows.",
      mstodo_step_3_1: "Set Name to Your app name.",
      mstodo_step_3_2:
        "Set »Supported account types« to »Accounts in any organizational directory and personal Microsoft accounts«.",
      mstodo_step_3_3:
        "Under Redirect URI, set the first drop-down to Web and set the value to https://api.glancr.de/auth-proxy/microsoft-todo/callback/",
      mstodo_step_4:
        "Choose Register. On the Your app name« page, copy the value of the Application (client) ID and save it, you will need it in the next step.",
      mstodo_step_5:
        "Select Certificates & secrets under Manage. Select the New client secret button. Enter a value in Description and select one of the options for Expires and choose Add.",
      mstodo_step_6:
        "Copy the client secret value before you leave this page. You will need it in the next step. This client secret is never shown again, so make sure you copy it now.",
      mstodo_step_7:
        "Choose API permissions and add Tasks.Read and User.Read permissions",
      mstodo_success: "Successfully connected to your Microsoft account!",
    },
    deDe: {
      mstodo_setup_credentials:
        "Bitte erstelle eine neue Azure AD App um deine Zugangsdaten zu generieren.",
      mstodo_instructions_summary: "Detaillierte Anweisungen ansehen",
      mstodo_step_1:
        "Melde dich mit einem persönlichen Konto (aka: Microsoft-Konto) oder einem Arbeits- oder Schulkonto an.",
      mstodo_step_2:
        "Wähle Azure Active Directory in der linken Navigation, dann wähle App Registrierungen unter Verwalten.",
      mstodo_step_3:
        "Wähle Neue Registrierung. Auf der Seite Registriere eine Anwendung, setze die Werte wie folgt.",
      mstodo_step_3_1: "Setze Name auf deinen App-Namen.",
      mstodo_step_3_2:
        "Setze »Unterstützte Account-Typen« auf »Accounts in einem beliebigen Organisationsverzeichnis und persönliche Microsoft-Accounts«.",
      mstodo_step_3_3:
        "Unter URI umleiten, setze das erste Drop-Down-Menü auf Web und den Wert auf https://api.glancr.de/auth-proxy/microsoft-todo/callback/",
      mstodo_step_4:
        "Wähle Registrieren. Kopiere auf der Seite »Dein App-Name« den Wert der Anwendungs- (Client-)ID und speichere sie, du wirst sie im nächsten Schritt benötigen.",
      mstodo_step_5:
        "Wähle Zertifikate & Geheimnisse unter Verwalten aus. Wähle die Schaltfläche Neues Clientgeheimnis. Gib einen Wert in Beschreibung ein und wähle eine der Optionen für Verfällt und wähle Hinzufügen.",
      mstodo_step_6:
        "Kopiere den geheimen Wert des Clients, bevor du diese Seite verlässt. Du wirst ihn im nächsten Schritt benötigen. Dieses Clientgeheimnis wird nie wieder gezeigt, also kopiere es jetzt unbedingt.",
      mstodo_step_7:
        "Wähle die API-Berechtigungen und füge die Berechtigungen Tasks.Read und User.Read hinzu",
      mstodo_success: "Erfolgreich mit deinem Microsoft-Konto verbunden!",
    },
    frFr: {
      mstodo_setup_credentials:
        "Veuillez créer une nouvelle application Azure AD pour générer vos identifiants.",
      mstodo_instructions_summary: "Voir les instructions détaillées",
      mstodo_step_1:
        "Connectez-vous à l'aide d'un compte personnel (alias : compte Microsoft) ou d'un compte professionnel ou scolaire.",
      mstodo_step_2:
        "Sélectionnez Azure Active Directory dans la navigation de gauche, puis sélectionnez Enregistrements d'applications sous Gérer.",
      mstodo_step_3:
        "Seleccione Nuevo registro. En la página Registrar una aplicación, configure los valores como se indica a continuación.\n- Establece Name en Your app name.\n- Establezca los tipos de cuenta admitidos en »Cuentas de cualquier directorio organizativo y en cuentas personales de Microsoft«.\n- En Redireccionar URI, establezca el primer desplegable en Web y establezca el valor en https://api.glancr.de/auth-proxy/microsoft-todo/callback/",
      mstodo_step_3_1: "Establece Name en Your app name.",
      mstodo_step_3_2:
        "Establezca los tipos de cuenta admitidos en »Cuentas de cualquier directorio organizativo y en cuentas personales de Microsoft«.",
      mstodo_step_3_3:
        "En Redireccionar URI, establezca el primer desplegable en Web y establezca el valor en https://api.glancr.de/auth-proxy/microsoft-todo/callback/",
      mstodo_step_4:
        "Choisissez Enregistrer. Sur la page »Votre nom d'application«, copiez la valeur de l'ID de l'application (client) et enregistrez-la, vous en aurez besoin à l'étape suivante.",
      mstodo_step_5:
        "Sélectionnez Certificats et secrets sous Gérer. Sélectionnez le bouton Nouveau secret du client. Entrez une valeur dans Description et sélectionnez une des options pour Expirations et choisissez Ajouter.",
      mstodo_step_6:
        "Copiez la valeur du secret professionnel avant de quitter cette page. Vous en aurez besoin à l'étape suivante. Ce secret de client n'est plus jamais révélé, alors assurez-vous de le copier maintenant.",
      mstodo_step_7:
        "Choisissez les permissions API et ajoutez les permissions Tasks.Read et User.Read",
      mstodo_success: "Connexion réussie à votre compte Microsoft!",
    },
    esEs: {
      mstodo_setup_credentials:
        "Por favor, cree una nueva aplicación Azure AD para generar sus credenciales.",
      mstodo_instructions_summary: "Vea las instrucciones detalladas",
      mstodo_step_1:
        "Ingresa usando una cuenta personal (alias: Cuenta de Microsoft) o una cuenta de trabajo o de escuela.",
      mstodo_step_2:
        "Seleccione Azure Active Directory en la navegación de la izquierda, y luego seleccione Registros de aplicaciones en Administrar.",
      mstodo_step_3:
        "Seleccione Nuevo registro. 4. En la página Registrar una aplicación, configure los valores como se indica a continuación.",
      mstodo_step_3_1: "Establece Name en Your app name.",
      mstodo_step_3_2:
        "Establezca los tipos de cuenta admitidos en Cuentas de cualquier directorio organizativo y en cuentas personales de Microsoft.",
      mstodo_step_3_3:
        "En Redireccionar URI, establezca el primer desplegable en Web y establezca el valor en https://api.glancr.de/auth-proxy/microsoft-todo/callback/",
      mstodo_step_4:
        "Elija Registrar. En la página »Your app name«, copie el valor del ID de la aplicación (cliente) y guárdelo, lo necesitará en el siguiente paso.",
      mstodo_step_5:
        "Seleccione Certificados y secretos en Administrar. Seleccione el botón Nuevo secreto del cliente. Introduzca un valor en Descripción y seleccione una de las opciones de Caduca y seleccione Añadir.",
      mstodo_step_6:
        "Copia el valor secreto del cliente antes de salir de esta página. Lo necesitarás en el siguiente paso. Este secreto del cliente nunca más se muestra, así que asegúrate de copiarlo ahora.",
      mstodo_step_7:
        "Elija los permisos de la API y añada los permisos de Tareas.de Lectura y de Usuario.de Lectura",
      mstodo_success: "¡Conectado con éxito a su cuenta de Microsoft!",
    },
    plPl: {
      mstodo_setup_credentials:
        "Proszę utworzyć nową aplikację Azure AD, aby wygenerować swoje dane uwierzytelniające.",
      mstodo_instructions_summary: "Patrz szczegółowe instrukcje",
      mstodo_step_1:
        "Zaloguj się przy użyciu konta osobistego (alias: Konto Microsoft) lub konta pracy lub szkoły.",
      mstodo_step_2:
        "Wybierz Azure Active Directory w nawigacji po lewej stronie, a następnie wybierz App registrations w obszarze Manage.",
      mstodo_step_3:
        "Wybierz opcję Nowa rejestracja. Na stronie Zarejestruj aplikację, ustaw następujące wartości.",
      mstodo_step_3_1: "Nadaj nazwę swojej aplikacji.",
      mstodo_step_3_2:
        "Ustaw obsługiwane typy kont na »Konta w dowolnym katalogu organizacyjnym i osobiste konta Microsoft«.",
      mstodo_step_3_3:
        "W obszarze Redirect URI ustaw pierwszą rozwijaną listę na Web i ustaw wartość na https://api.glancr.de/auth-proxy/microsoft-todo/callback/",
      mstodo_step_4:
        "Wybierz Register. Na stronie »Twoja nazwa aplikacji« skopiuj wartość identyfikatora aplikacji (klienta) i zapisz go, będzie Ci on potrzebny w następnym kroku.",
      mstodo_step_5:
        "W sekcji Zarządzaj wybierz Certyfikaty i tajemnice. Wybierz przycisk Nowa tajemnica klienta. Wprowadź wartość w Opisie i wybierz jedną z opcji dla Wygasa i wybierz Dodaj.",
      mstodo_step_6:
        "Skopiuj tajną wartość klienta przed opuszczeniem tej strony. Będziesz jej potrzebował w następnym kroku. Ten sekret klienta nigdy więcej nie zostanie pokazany, więc upewnij się, że go teraz skopiujesz.",
      mstodo_step_7:
        "Wybierz uprawnienia API i dodaj uprawnienia Tasks.Read i User.Read",
      mstodo_success: "Pomyślnie połączono z Twoim kontem Microsoft!",
    },
    koKr: {
      mstodo_setup_credentials:
        "자격 증명을 생성하려면 새로운 Azure AD 앱을 만드십시오.",
      mstodo_instructions_summary: "자세한 지침보기",
      mstodo_step_1:
        "개인 계정 (일명 : Microsoft 계정) 또는 회사 또는 학교 계정을 사용하여 로그인합니다.",
      mstodo_step_2:
        "왼쪽 탐색에서 Azure Active Directory를 선택한 다음 관리에서 앱 등록을 선택합니다.",
      mstodo_step_3:
        "새 등록을 선택합니다. 애플리케이션 등록 페이지에서 다음과 같이 값을 설정하십시오.",
      mstodo_step_3_1: "이름을 앱 이름으로 설정합니다.",
      mstodo_step_3_2:
        "지원되는 계정 유형을 모든 조직 디렉터리 및 개인 Microsoft 계정의 계정으로 설정합니다.",
      mstodo_step_3_3:
        "리디렉션 URI에서 첫 번째 드롭 다운을 Web으로 설정하고 값을 https://api.glancr.de/auth-proxy/microsoft-todo/callback/ 으로 설정합니다.",
      mstodo_step_4:
        "등록을 선택합니다. 앱 이름 페이지에서 애플리케이션 (클라이언트) ID의 값을 복사하고 저장합니다. 다음 단계에서 필요합니다.",
      mstodo_step_5:
        "관리에서 인증서 및 비밀을 선택합니다. 새 클라이언트 비밀 버튼을 선택합니다. 설명에 값을 입력하고 만료 옵션 중 하나를 선택한 다음 추가를 선택합니다.",
      mstodo_step_6:
        "이 페이지를 떠나기 전에 클라이언트 암호 값을 복사하십시오. 다음 단계에서 필요합니다. 이 클라이언트 암호는 다시 표시되지 않으므로 지금 복사하십시오.",
      mstodo_step_7:
        "API 권한을 선택하고 Tasks.Read 및 User.Read 권한을 추가합니다.",
      mstodo_success: "Microsoft 계정에 성공적으로 연결되었습니다!",
    },
  },
};
</script>
<style>
.mstodo--selectable {
  user-select: text;
  -moz-user-select: text;
  -webkit-user-select: text;
}
</style>
